package ch.zhaw.ads;

public class BracketServer implements CommandExecutor {



    @Override
    public String execute(String command) throws Exception {
        return checkBrackets(command) ? "true" : "false";
    }

    public boolean checkBrackets (String arg) {
        Stack stack = new ListStack();
        char[] chars = arg.toCharArray();
        for (char x: chars) {
            Character closingBracket = getClosingBracketForOpening(x);
            if(closingBracket != null){
                stack.push(closingBracket);
            } else if(isClosingBracket(x) && stack.pop() != (Character)x) {
                return false;
            }
        }
        if(stack.isEmpty()){
            return true;
        } else {
            return false;
        }
    }

    private Character getClosingBracketForOpening(char openingBracket) {
        switch (openingBracket){
            case '(':
                return ')';
            case '[':
                return ']';
            case '{':
                return '}';
        }
        return null;
    }

    private boolean isClosingBracket(char x) {
        return x == ')' || x == ']' || x == '}';
    }

}